function cmodulo(nMod,tCampo,campo,accion,nTam,cIni,cFin,tipo) {
	vGtam="100%"
	vGmodulo=nMod
	if(sessionStorage.hasOwnProperty("modulo")){
		sessionStorage.removeItem("modulo")
	}
	sessionStorage.setItem("modulo",nMod)
	if(sessionStorage.hasOwnProperty("tipo")){
		sessionStorage.removeItem("tipo")
	}
	sessionStorage.setItem("tipo",tipo)
	if(sessionStorage.hasOwnProperty("campoi")){
		sessionStorage.removeItem("campoi")
	}
	sessionStorage.setItem("campoi",cIni)
	if(sessionStorage.hasOwnProperty("length")){
		sessionStorage.removeItem("length")
	}
	sessionStorage.setItem("length",nTam)
	if(sessionStorage.hasOwnProperty("accion")){
		sessionStorage.removeItem("accion")
	}
	sessionStorage.setItem("accion",accion)
	if(nTam!=''){
		vGtam=nTam
	}
	dSw==0
	if(accion!="g"){
		hide_search_list();
	}
	DetalleB="";
	tAcc=accion;
	if(tAcc=="v"){
		alert("Esta presentacion no admite la acción guardar");
		return;
	}
	tId=campo;
	url="modulo="+nMod;
	url+="&tipo="+"l";
	url+="&accion="+accion;
	url+="&codemp="+VGempresa;
	console.log(accion)
	document.getElementById("lderecho").innerHTML="";
	var Rpage =VGRutaRiz+"controllers/modulos/"
	doAjax(Rpage,url,'resp_cmodulos_listf','gets','0','Ccargar','');
}

function resp_cmodulos_listf(ResTex,param) {
	console.log(ResTex);
	Detalle="";
	DetalleB="";
	DetalleM="";
	DetalleT="<p>"+localStorage.getItem("modulo")+"</p>";
	tMod="";
	vC="";
	vJfunciones='{"Datos":[{';
	var oJsonDatos = JSON.parse(ResTex);
	var nMod="",tCampo=0;
	if(oJsonDatos.Datos!="ERROR"){
	    if(ResTex.length>1){
			cad=oJsonDatos.Datos[0];
			console.log(Object.keys(cad));
			nMod=oJsonDatos.Datos[0].tabla.trim()
			DetalleT="<p>"+oJsonDatos.Datos[0].titmod.trim()+"</p>";
			DetalleM="<h4>"+oJsonDatos.Datos[0].titmod.trim()+"</h4><br>"
			tMod=oJsonDatos.Datos[0].nommod.trim();
			DetalleM+="<p>"+oJsonDatos.Datos[0].obsmod.trim()+"</p><br><p>Para Crear siga los siguientes pasos:</p><br>"
			JsonActividad=ResTex;
			var oJsonDatos = JSON.parse(JsonActividad);
	        var NJsonItem=oJsonDatos.Datos.length;
			vDiv=""
			iDet=0//para saber en que campo arranca el detalle
			swdet=0
			for (RowArray=0;RowArray<NJsonItem; RowArray++){
				if(oJsonDatos.Datos[RowArray].inicio){swdet=1}
				tCampo=RowArray;
				vCampo="c"+RowArray.toString()
				if(RowArray==0){
					Detalle+=oJsonDatos.Datos[RowArray].titulo+"<div id='"+oJsonDatos.Datos[RowArray].bloque+"' class='"+oJsonDatos.Datos[RowArray].clase+"'>"
					vDiv=oJsonDatos.Datos[RowArray].bloque.trim()
				}else{
					if(vDiv!=oJsonDatos.Datos[RowArray].bloque.trim()){
						if(vDiv=='bloquedet'){
							Detalle+='<a href="javascript:guardardetalle(\''+oJsonDatos.Datos[RowArray].nommod.trim()+'\',\''+iDet+'\',\''+(RowArray-1)+'\',\'c0\')">+ Agregar Item</a>';
							Detalle+="<div id='det_prod' class='form-msg'>...</div>"
						}
						Detalle+="</div>";
						Detalle+=oJsonDatos.Datos[RowArray].titulo+"<div id='"+oJsonDatos.Datos[RowArray].bloque+"' class='"+oJsonDatos.Datos[RowArray].clase+"'>"
						vDiv=oJsonDatos.Datos[RowArray].bloque.trim()
						}
					}
					Detalle+="<div class='"+oJsonDatos.Datos[RowArray].nomdiv+"' id='"+oJsonDatos.Datos[RowArray].nombre.trim()+"'"
					if(oJsonDatos.Datos[RowArray].campoadi.trim()!=""){
						Detalle+=" title='"+oJsonDatos.Datos[RowArray].campoadi.trim()+"'"
					}
					if(oJsonDatos.Datos[RowArray].chkocu==1 && tAcc!="r"){
						Detalle+="' style='display: none' "
					}
					Detalle+=">";
					if(oJsonDatos.Datos[RowArray].inicio.trim().length>3){Detalle+="<div id='buscador"+vCampo+"'></div>"}
					Detalle+=oJsonDatos.Datos[RowArray].htmlinicial.trim().replace('rrr',vCampo);
					Detlabel=""
					if(oJsonDatos.Datos[RowArray].nomdiv.trim()=="drag-area"){
						Detalle+="<h2>Arrastra y suelta imagenes</h2>"
						Detalle+="<span>0</span>"
						Detalle+="<button>Selecciona tus archivos</button>"
					}else{
						cDescripcion=oJsonDatos.Datos[RowArray].descripcion;
						console.log(oJsonDatos.Datos[RowArray].funcionlabel);
						if(oJsonDatos.Datos[RowArray].foreti.trim()!=""){
							
							if(oJsonDatos.Datos[RowArray].etiini.trim()=="table"){
								Detalle+='<a href="javascript:crear(\''+oJsonDatos.Datos[RowArray].lost.trim()+'\')">'
							}
							Detlabel+='<label for="'+oJsonDatos.Datos[RowArray].foreti.trim()+'"'+oJsonDatos.Datos[RowArray].funcionlabel.trim()+" >"
							if(oJsonDatos.Datos[RowArray].description!=''){
								Detlabel+="<span>"+oJsonDatos.Datos[RowArray].description+"</span>";
							}else{
								Detlabel+="<span>"+cDescripcion+"</span>";
							}
							
							Detlabel+="</label>"
							if(oJsonDatos.Datos[RowArray].etiini.trim()=="table"){
								Detalle+='</a>'
							}
						}else{
							if(oJsonDatos.Datos[RowArray].etiini.trim()=="table"){
								Detalle+='<a href="javascript:crear(\''+oJsonDatos.Datos[RowArray].lost.trim()+'\')">'
							}
							if(oJsonDatos.Datos[RowArray].nombre.substr(0,3)=='chk'){
							}else{
								if (oJsonDatos.Datos[RowArray].funcionlabel.length>=2){
									cFuncion=oJsonDatos.Datos[RowArray].funcionlabel.trim();
									if(oJsonDatos.Datos[RowArray].funcionlabel.includes("this")){
										cFuncion=cFuncion.replace("this",vCampo);
										console.log(cFuncion)
									}
										
									Detalle+='<a href="'+cFuncion+'" >'+cDescripcion+'</a>';
								}else{
									Detlabel+="<label for=''>"
									if(oJsonDatos.Datos[RowArray].description.length>=2){
									//	Detalle+=oJsonDatos.Datos[RowArray].description+"</label>";
										Detlabel+=oJsonDatos.Datos[RowArray].description+"</label>";
									}else{
									//	Detalle+=cDescripcion+"</label>";
										Detlabel+=cDescripcion+"</label>";
									}
								}
							}
							if(oJsonDatos.Datos[RowArray].etiini.trim()=="table"){
								Detalle+='</a>'
							}
						}
					}
					if(oJsonDatos.Datos[RowArray].funcion!=""){//Agregar lupa si es funcion y agregar nuevo si es chknew=1
						Detalle+="<i class='icon-arrow-with-circle-left:before'>&#128193</i>";
					}
					Detalle+="<"+oJsonDatos.Datos[RowArray].etiini+" id='"+vCampo+"' name='"+oJsonDatos.Datos[RowArray].nombre+"'"; if(oJsonDatos.Datos[RowArray].etiini=='select' && oJsonDatos.Datos[RowArray].chkvar==1){Detalle+=" multiple"};
					if(oJsonDatos.Datos[RowArray].tipo=="int"){
						Detalle+=" pattern='^[0-9]+' min='0' onkeypress='comprueba(this)' "//valido que solo sea numeros positivos
					}
					if(oJsonDatos.Datos[RowArray].funcion!=""){//para buscardor al escribir

						Detalle+=' onkeyup="buscador(\''+oJsonDatos.Datos[RowArray].funcion+'\',\'this\',\''+oJsonDatos.Datos[RowArray].chknew+'\')" '//valido que solo sea numeros positivos
					}
					aReq=""
					aImg=""
					if(oJsonDatos.Datos[RowArray].nomdiv=='conte_foto'){
						aImg="archi_img"
					}
					if(oJsonDatos.Datos[RowArray].chkreq=="1" ){
						aReq+=" required "//valido que solo sea numeros positivos
					}
					if(vDiv=="bloquedet"){
						Detalle+=" class='bloquedet "+aReq+" "+tMod+" txtdata' "
						if( iDet==0){
							iDet=RowArray;
						}
					}else{
						Detalle+="class='"+tMod
						if(oJsonDatos.Datos[RowArray].chkdet=="1"){
							Detalle+=" general "	
						}
						if(aReq!=''){
							Detalle+=" "+aReq
						}
						if(aImg!=''){
							Detalle+=" "+aImg
						}
						Detalle+=" txtdata'"
					}
					Detalle+=" required ";
					if(oJsonDatos.Datos[RowArray].interactive.trim().length>3){
						Detalle+=oJsonDatos.Datos[RowArray].interactive.trim();
					}
					if(oJsonDatos.Datos[RowArray].inicio.trim().length>3){
						if(vJfunciones.length>12){vJfunciones+=",{";}
						vJfunciones+='"modulo":"'+oJsonDatos.Datos[RowArray].inicio.trim()+'",';
						vJfunciones+='"objeto":"'+vCampo+'",';
						
						if(oJsonDatos.Datos[RowArray].predeterminado.trim()!=""){
							vJfunciones+='"valor":"'+localStorage.getItem(oJsonDatos.Datos[RowArray].predeterminado.trim())+'",';
						}else{
							vJfunciones+='"valor":"",';
						}
						
						if(oJsonDatos.Datos[RowArray].condicion.trim()!=""){
							vJfunciones+='"condicion":"'+oJsonDatos.Datos[RowArray].condicion.trim()+'"';
						}else{
							vJfunciones+='"condicion":""';
						}
						vJfunciones+=',"modalidad":"'+oJsonDatos.Datos[RowArray].chkimg.trim()+'"';
						vJfunciones+=',"lost":"'+oJsonDatos.Datos[RowArray].lost.trim()+'"';
						vJfunciones+='}';
					}else{
						if(oJsonDatos.Datos[RowArray].predeterminado.trim()!="" ){
							//&& (VGrol=='docente' || VGrol=='estudiante')
							vPred=oJsonDatos.Datos[RowArray].predeterminado.trim()
							if((vPred=='docente' || vPred=='estudiante') && VGrol!='docente' && VGrol!='estudiante'){
							}else{
								Detalle+=" value='"+localStorage.getItem(oJsonDatos.Datos[RowArray].predeterminado.trim())+"' "
							}
						}
					}
					if(oJsonDatos.Datos[RowArray].lost.trim()!=""){
						Detalle+=' onblur="'+oJsonDatos.Datos[RowArray].lost.trim()+'"'
					}
					if(VGrol=='docente' || VGrol=='estudiante'){
						Detalle+=" disabled"
					}
						Detalle+=" >"
					
						if(oJsonDatos.Datos[RowArray].nombre.substr(0,3)=='chk'){
							Detlabel+="<label for='"+vCampo+"'  >"
							if(oJsonDatos.Datos[RowArray].description.length>=2){
								Detlabel+=oJsonDatos.Datos[RowArray].description+"</label>";
							}else{
								Detlabel+=oJsonDatos.Datos[RowArray].descripcion+"</label>";
							}
						}

					DetalleM+=RowArray;
					//***********************SI CLASE NO ES BLOQUEPH
					//if(oJsonDatos.Datos[RowArray].clase!="bloqueph"){
					//	Detalle+=Detlabel;
						
					//}
					if(oJsonDatos.Datos[RowArray].etiini=='select'){DetalleM+=") Seleccione: "
						}else{DetalleM+=") Digite: "}
					DetalleM+=oJsonDatos.Datos[RowArray].descripcion.trim()+"<br>"
					
					if(oJsonDatos.Datos[RowArray].extensiones.trim()!=""){
						Detalle+="<p> Extensiones permitidas: "+oJsonDatos.Datos[RowArray].extensiones+"</p>";	
						}
						Detalle+=oJsonDatos.Datos[RowArray].valorhtml.trim();	
					
					Detalle+="</"+oJsonDatos.Datos[RowArray].etifin+">";	
					Detalle+=oJsonDatos.Datos[RowArray].htmlfinal.trim().replace('rrr',vCampo);
					//Detalle+="</label>";//25-08-2023
					//if(oJsonDatos.Datos[RowArray].clase=="bloqueph"){//**********POR EL NUEVO CSS DE CLASE BLOQUEPH
						Detalle+=Detlabel;
					//}
					Detalle+="</div>";
					if(vDiv=='bloquedet' && RowArray==NJsonItem-1){
						Detalle+='<a href="javascript:guardardetalle(\''+oJsonDatos.Datos[RowArray].nommod.trim()+'\',\''+iDet+'\',\''+RowArray+'\',\'c0\')">+ Agregar Item</a>';
						Detalle+="<div id='det_prod' class='form-msg'>...</div>"
					}	
			}
			DetalleM+='<br>Luego de click en el icono <span class="icon-save" ></span>';
			DetalleB+='<a href="javascript:limpiar(\'' + localStorage.getItem("modulo") + '\');" id="bnuevo"><div class="circulo_sup"><span class="icon-circle-with-plus" ></span></div></a>'
			if(tAcc!="l"){
				DetalleB+='<a href="javascript:rmodulo(\'' + localStorage.getItem("modulo") + '\',\'' + tCampo + '\',\'' + tId + '\',\''+tAcc+'\',\'\',\'\',\'\',\''+localStorage.getItem("tipo")+'\');" id="bguardar"><div class="circulo_sup"><span class="icon-save" ></span></div></a>'
			}   
			//if(localStorage.getItem("Codempresa")=='DND'){
				DetalleB+='<a href="javascript:listados(\'' + localStorage.getItem("modulo") + '\');" id="blistar"><div class="circulo_sup"><span class="icon-list" ></span></div></a>'
			//}else{      
		   // DetalleB+='<a href="javascript:cmodulo(\'' + localStorage.getItem("modulo") + '\',\'' + vC + '\',\'' + vC + '\',\'l\',\'\',\'\',\'\',\''+localStorage.getItem("tipo")+'\');" id="blistar"><div class="circulo_sup"><span class="icon-list" ></span></div></a>'
			//}
			Detalle+="</div>";	
		}else{
			Detalle+="</div>";
			
			DetalleB+='<a href="javascript:limpiar(\'' + localStorage.getItem("modulo") + '\');" id="bnuevo"><div class="circulo_sup"><span class="icon-circle-with-plus" ></span></div></a>'
			if(tAcc!="l"){
				DetalleB+='<a href="javascript:rmodulo(\'' + localStorage.getItem("modulo") + '\',\'' + tCampo + '\',\'' + tId + '\',\''+tAcc+'\',\'\',\'\',\''+localStorage.getItem("tipo")+'\');" id="bguardar"><div class="circulo_sup"><span class="icon-save" ></span></div></a>'
			}
			//if(localStorage.getItem("Codempresa")=='DND'){
				DetalleB+='<a href="javascript:listados(\'' + localStorage.getItem("modulo") + '\');" id="blistar"><div class="circulo_sup"><span class="icon-list" ></span></div></a>'
			//}else{
			//	DetalleB+='<a href="javascript:cmodulo(\'' + localStorage.getItem("modulo") + '\',\'' + vC + '\',\'' + vC + '\',\'l\',\'\',\'\',\''+localStorage.getItem("tipo")+'\');" id="blistar"><div class="circulo_sup"><span class="icon-list" ></span></div></a>'
			//}
				
			alert("no registro");
			
	    }
	}else{
		DetalleB+='<a href="javascript:limpiar(\'' + localStorage.getItem("modulo") + '\');" id="bnuevo"><div class="circulo_sup"><span class="icon-circle-with-plus" ></span></div></a>'
			if(tAcc!="l"){
				DetalleB+='<a href="javascript:rmodulo(\'' + localStorage.getItem("modulo") + '\',\'' + tCampo + '\',\'' + tId + '\',\''+tAcc+'\',\'\',\'\',\''+localStorage.getItem("tipo")+'\');" id="bguardar"><div class="circulo_sup"><span class="icon-save" ></span></div></a>'
			}
			//if(localStorage.getItem("Codempresa")=='DND'){
				DetalleB+='<a href="javascript:listados(\'' + localStorage.getItem("modulo") + '\')><div class="circulo_sup"><span class="icon-list" ></span></div></a>'
			//}else{
			//	DetalleB+='<a href="javascript:cmodulo(\'' + localStorage.getItem("modulo") + '\',\'' + vC + '\',\'' + vC + '\',\'l\');" id="blistar"><div class="circulo_sup"><span class="icon-list" ></span></div></a>'
			//}
		//document.getElementById("detcuerpo").innerHTML="Modulo invalido"+'</div><div id="reporte" style="background-color:white;"></div>';
    }
	if(VGrol=='empleado'){
		DetalleB+='<a href="javascript:cmodulo(\'' + localStorage.getItem("modulo") + '\',\'' + vC + '\',\'' + vC + '\',\'g\',\''+vGtam+'\',\''+vGcampoi+'\',\''+vGcampof+'\');" id="bnuevo">	<div class="circulo_sup"><span class="icon-circle-with-plus" ></span></div></a>'
			DetalleB+='<a href="javascript:rmodulo(\'' + localStorage.getItem("modulo") + '\',\'' + tCampo + '\',\'' + tId + '\',\''+tAcc+'\');" id="bguardar"><div class="circulo_sup"><span class="icon-save" ></span></div></a>'
            DetalleB+='<a href="javascript:imodulo(\'' + localStorage.getItem("modulo") + '\',\'' + vC + '\',\'' + vC + '\',\'' + vC + '\');" id="blistar"><div class="circulo_sup"><span class="icon-list" ></span></div></a>'

			tMod=vGmodulo;	
	}
	if(localStorage.hasOwnProperty("id")){
		localStorage.removeItem("id")
	}
	if(localStorage.hasOwnProperty("accion")){
		localStorage.removeItem("accion")
	}
	if(localStorage.hasOwnProperty("tcampo")){
		localStorage.removeItem("tcampo")
		
	}
	Detalle=rpt_textos(Detalle);
	DetalleT=rpt_textos(DetalleT);
	DetalleSup="<div class='superior'><div id='sup_izquierda' class='sup_izquierda'>"+DetalleT+"</div><div id='sup_derecha' class='sup_derecha'></div></div>"
	Detalle+='<div id="reporte" style="background-color:white;"></div>'
	Detalle+="<div id='div_tabla' class='bloqueh'>..</div><div id='mdi_resumen' class='bloqueh'>..</div>"
		
	vJfunciones+="]}";
	if(tAcc=="e" ){
		localStorage.setItem("accion",'e')
		localStorage.setItem("tid",tId)
		localStorage.setItem("tcampo",tCampo)
	}
	console.log(vGmodulo)
	if (vGmodulo=='cajamenor'   ){
		if(tAcc!="l"){
			insertar(Detalle,vJfunciones,DetalleSup,DetalleB)
		}else{
			imodulo(localStorage.getItem('modulo'),'','','');//verificar porque no dice lmodulo
		}
		return
	}
	console.log(Detalle+DetalleB)
	document.getElementById("mdi_botones").innerHTML=DetalleSup
	document.getElementById("detcuerpo").innerHTML=Detalle;
	document.getElementById("sup_izquierda").innerHTML=DetalleT;
	document.getElementById("sup_derecha").innerHTML=DetalleB;
	document.getElementById("ibuscar").innerHTML="";
	
	
	if(tAcc=="l"){
		var loc = window.location;
		console.log(localStorage.getItem("Codempresa"))
    	var pathName = loc.pathname.substring(0, loc.pathname.lastIndexOf('/') + 1);
		ruta=loc.href.substring(0, loc.href.length - ((loc.pathname + loc.search + loc.hash).length - pathName.length));
		//if(localStorage.getItem("Codempresa")=='DND'){
			listados(ruta,Detalle,vJfunciones,DetalleSup,DetalleB)
		//}else {
		//	lmodulo(localStorage.getItem('modulo'),'','','');
		//}
		return 
	}
	console.log(DetalleT)
	console.log(Detalle)
	
	document.getElementById("mdi_tablero").style.height="100%"//estaba en 80% al 11-01-2023
	//if(localStorage.getItem("Codempresa")=='DND' ){
		elem=document.getElementsByClassName('bloqueph')
	//}else{
	//	elem=document.getElementsByClassName('bloque')
	//}
	console.log(vGtam)
	console.log(localStorage.getItem("Codempresa"))
	elem[0].style.width=vGtam;
	
	console.log(vJfunciones.length)
	
	if(vJfunciones.length>13){
		console.log(vJfunciones)
		vGnum=0;
		jGfunciones = JSON.parse(vJfunciones);
		filtrar(jGfunciones.Datos[0].modulo,jGfunciones.Datos[0].objeto,jGfunciones.Datos[0].valor,jGfunciones.Datos[0].condicion,jGfunciones.Datos[0].modalidad,jGfunciones.Datos[0].lost);
	}else{
	}
}